=== debian/changelog ===
llvm-2.9 (2.9+dfsg-1~exp1) experimental; urgency=low

  * New upstream release
  * debian/patches/0003-Debian-version-info-and-bugreport.patch, 
    debian/patches/0005-Disable-llvm-stub.patch, 
    debian/patches/0008-path-eraseFromDisk.patch, 
    debian/patches/0011-Hurd-fixes.patch,
    debian/patches/0021-shared-lib-debian.patch,
    debian/patches/0031-mips-version-script.patch
    updated
  * debian/patches/0004-Pretend-final-release.patch,
    debian/patches/0019-issue6065.patch
    removed
  * debian/debhelper.in/llvm-runtime.prerm,
    debian/debhelper.in/llvm-runtime.postinst: uses the exact version of llvm
    to call binfmt
  * debian/orig-tar.sh: repacking script added to remove a non DFSG file
  * Update of the copyright list

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 17 Apr 2011 02:30:13 +0200

llvm-2.8 (2.8-2) unstable; urgency=low

  * Upload in unstable
  * Update of the tags Vcs-Svn, Vcs-Browser and uploader
  * watch file added
  * Standards-Version updated to version 3.9.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 Feb 2011 23:48:42 +0100

llvm-2.8 (2.8-1) experimental; urgency=low

  * Sync from Ubuntu
  * New upstream release (Closes: #601074)
     * llc no longer segfault when dealing with invalid bitcode 
       (Closes: #588708)
  * Add myself to the uploaders.
  * Install vim files at the right place (Closes: #605855)
  * Manpage renamed (Closes: #592342)
  * Update llvm.binfmt to be able to execute LLVM bitcode directly
    (Closes: #610585)
  * Some manpages were badly named (Closes: #592342)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 Feb 2011 00:45:50 +0100

llvm-2.8 (2.8-0ubuntu1) maverick; urgency=low

  * LLVM-2.8 final release. LP: #632727.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Oct 2010 13:34:22 +0200

llvm-2.8 (2.8~20100921-0ubuntu2) maverick; urgency=low

  * llvm-2.8-dev: Install versioned 2.8 vim files.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Sep 2010 19:21:25 +0200

llvm-2.8 (2.8~20100921-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 21 Sep 2010 14:03:34 +0200

llvm-2.8 (2.8~20100911-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.
    - ARM regression fixes.
    - They call it rc now instead of svn. Let's believe it despite
      the regressions on powerpc.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Sep 2010 00:44:44 +0200

llvm-2.8 (2.8~20100907-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.
  * Provide a symlink /usr/lib/llvm-2.8svn -> llvm-2.8.
  * Merge build fixes from clang and llvm-gcc-4.2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Sep 2010 17:51:17 +0200

llvm-2.8 (2.8~20100906-0ubuntu2) maverick; urgency=low

  * llvm-2.8: Don't include lli-2.8, already included in llvm-2.8-runtime.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Sep 2010 12:09:36 +0200

llvm-2.8 (2.8~20100906-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.
  * Do not provide unversioned names for binaries. LP: #625644, #626108.
  * Fix order of debhelper calls. LP: #625437.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Sep 2010 16:05:03 +0200

llvm-2.8 (2.8~20100826-0ubuntu1) maverick; urgency=low

  * New upstream snapshot.
  * Merge changes from 2.7-5.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Aug 2010 12:54:23 +0200

llvm-2.7 (2.7-5) unstable; urgency=low

  * debian/debhelper.in/llvm-dev.install, debian/packages.d/llvm.mk:
    Move vim files to /usr/share/vim/addons/plugin/.  Closes: #593188.
  * Fix clang -fstack-protector link errors. Thanks to Anders Kaseorg!
    Closes: #592009.
    - debian/patches/0032-x86-fast-isel-fs-load.patch: Add.
    - debian/patches/0033-stack-protector-linux.patch: Add.
  * debian/rules.d/control.mk: Don't corrupts patches. More thanks to
    Anders Kaseorg.  Closes: #593252.
  * debian/rules.d/binary.mk: Move dh_ocaml call to...
    debian/packages.d/llvm.mk (libllvm-ocaml-dev_extra_binary): ... Here.
  * Merge from llvm-gcc-4.2 2.7-3:
    - debian/rules.d/binary.mk: Call dh_strip after $*_extra_binary.
    - debian/packages.d/llvm-gcc-4.2.mk (llvm-gcc-4.2_extra_binary):
      Add GCC version to binaries.
    - debian/control.in/llvm-gcc-4.2: Provides llvm-gcc.
    - debian/debhelper.in/llvm-gcc-4.2.links: Add.
  * Merge from clang 2.7-3:
    - debian/debhelper.in/clang.install, debian/debhelper.in/clang.links:
      + Install all scan-{build,view} files into /usr/share/clang/.
        Addresses: #586194, #592301.
      + Install /usr/bin/clang++ symlink.  Addresses: #592301.
    - debian/packages.d/tools.mk: Fix cache location.
    - debian/control.in/clang: Recommends python.
  * debian/packages.d/llvm.mk (libllvm-ocaml-dev_extra_binary): Add
    upstream version to META file.

 -- Arthur Loiret <aloiret@debian.org>  Wed, 25 Aug 2010 17:08:47 +0000

llvm-2.7 (2.7-4ubuntu1) maverick; urgency=low

  [ Matthias Klose ]
  * Merge with Debian; remaining changes:
    - Don't build llvm-2.7-priv-dev, remove build dependency on
      llvm-2.7-priv-dev.
    - Adjust conflicts with unversioned llvm package as found in lucid.
  * Replace 0010-ARM-BX_to_BLX.patch by 0010-r109125.patch.  ARMv4 JIT forgets
    to set the lr register when making a indirect function call. Fixes PR7608.
  * Backports from 2.8 (taken from OpenEmbedded):
    - 0041-r104558-VFPmisc.patch: Add missing implementation to the
      materialization of VFP misc. instructions (vmrs, vmsr and vmov
      (immediate)).
    - 0042-r104587-MOVimm32.patch: Fix TestARMCodeEmitter::emitPseudoInstruction
      UNREACHABLE at ARMCodeEmitter.cpp:554.
    - 0043-r104652-VFPLoadStoreMultiple.patch: Fix PR7221, makes VFP
      calculations correct.
    - 0044-r104653-BFC-BFI.patch: Fix PR7222, ERROR: ARMv6t2 JIT is not yet
      supported.

