=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg.*//,uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,pasv \
http://llvm.org/releases/download.html (?:.*/)?llvm-?_?([\d+\.]+|\d+)\.(tar.*|tgz|zip|gz|bz2|) debian debian/orig-tar.sh
